var myAutoHideNameSpace = {
autohidebookmarks : {
  oldDisplay : "",
  oldDisplayMulti : "",
  timer:null,
  enableCTRL:true,
  enableAddon:false,
  enableDelay:true,
  delay:2,
  isVisible:true,
  onLoad: function() {
    // initialization code
	try{
		this.enableAddon = this.getBoolPref("enabled");
		this.enableDelay = this.getBoolPref("enableDelay");
		this.enableCTRL = this.getBoolPref("enableControl");
		this.delay = this.getStringPref("delay")*2;
		}	
	catch(e)
	{
		this.setBoolPref("enabled",true);
		this.setBoolPref("enableDelay",true);
		this.setBoolPref("enableControl",true);
		this.setStringPref("delay",2);
		
		this.enableAddon = true;
		this.enableDelay = true;
		this.enableCTRL = true;
		this.delay = 2;
	}
    var theBar = document.getElementById("PersonalToolbar");
	var theBarMulti = document.getElementById("personal-bookmarks");
	//alert(theBarMulti);
	this.oldDisplay = theBar.style.display;
	this.oldDisplayMulti = theBarMulti.style.display;
	myAutoHideNameSpace.autohidebookmarks.timer = Components.classes["@mozilla.org/timer;1"]
                    .createInstance(Components.interfaces.nsITimer);
		
	//wait 2 secs before hiding the bar for the first time so that the 'multi toolbar' works also
	myAutoHideNameSpace.autohidebookmarks.timer.initWithCallback(
	   myAutoHideNameSpace.autohidebookmarks.hideBookmarks,
	   2500,
	   Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	var toolbox = document.getElementById("navigator-toolbox");
	toolbox.addEventListener("mouseover", this.onMouseOver, false);
	toolbox.addEventListener("mouseout", this.onMouseOut, false);
	
  },
  toggleDisplay: function(e){
	if(myAutoHideNameSpace.autohidebookmarks.isVisible)
	{
		myAutoHideNameSpace.autohidebookmarks.enableAddon = true;
		myAutoHideNameSpace.autohidebookmarks.setBoolPref("enabled",true);
		myAutoHideNameSpace.autohidebookmarks.hideBookmarks();
		
	}
	else
	{
		myAutoHideNameSpace.autohidebookmarks.enableAddon = false;
		myAutoHideNameSpace.autohidebookmarks.setBoolPref("enabled",false);
		myAutoHideNameSpace.autohidebookmarks.unhideBookmarks();
	}
  },
  onMouseOver: function(e){
	if(myAutoHideNameSpace.autohidebookmarks.enableAddon)
	{
		if(myAutoHideNameSpace.autohidebookmarks.enableCTRL)
		{
			if(e.ctrlKey)
			{
				myAutoHideNameSpace.autohidebookmarks.unhideBookmarks();
			}
		}
		else
		{
			//show bar without CTRL key
			myAutoHideNameSpace.autohidebookmarks.unhideBookmarks();
		}
		myAutoHideNameSpace.autohidebookmarks.timer.cancel();
	}
  },
  onMouseOut: function(e){
	if(myAutoHideNameSpace.autohidebookmarks.enableAddon)
	{
	myAutoHideNameSpace.autohidebookmarks.timer.initWithCallback(
	   myAutoHideNameSpace.autohidebookmarks.hideBookmarks,
	   myAutoHideNameSpace.autohidebookmarks.delay*1000,
	   Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	}
  },
  hideBookmarks: function(){
	
		var theBar = document.getElementById("PersonalToolbar");
		theBar.style.display = "none";
		var theBarMulti = document.getElementById("personal-bookmarks");
		theBarMulti.style.display = "none";
		myAutoHideNameSpace.autohidebookmarks.isVisible = false;
	
  },
  unhideBookmarks: function(){
	var theBar = document.getElementById("PersonalToolbar");
	theBar.style.display = myAutoHideNameSpace.autohidebookmarks.oldDisplay;
	var theBarMulti = document.getElementById("personal-bookmarks");
	theBarMulti.style.display = myAutoHideNameSpace.autohidebookmarks.oldDisplay;
	myAutoHideNameSpace.autohidebookmarks.isVisible = true;
  },
  onOptions: function(e){
	var myOptionsWin = window.openDialog("chrome://autohidebookmarks/content/options.xul", "autoHideBookmarksOptionsWindow", "resizable,centerscreen", this);

  },
  getBoolPref: function(name){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.autohidebookmarks.");
	return prefs.getBoolPref(name);
  },
  setBoolPref: function(name, val){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.autohidebookmarks.");
	prefs.setBoolPref(name, val);
  },
  getStringPref: function(name){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.autohidebookmarks.");
	return prefs.getCharPref(name);
  },
  setStringPref: function(name, val){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.autohidebookmarks.");
	prefs.setCharPref(name, val);
  }
}
};
window.addEventListener("load", function(e) { myAutoHideNameSpace.autohidebookmarks.onLoad(e); }, false);
